// 
// Copy into your stdafx.h
//

/////////////////////////////////////////////////////////////////////////////////
// Start XML Archive support

#import <msxml.dll>

#define DECLARE_XMLSERIAL(className) DECLARE_SERIAL(className)\
	CRuntimeClass* GetActualClass() { return className::GetRuntimeClass(); }; 
#define IMPLEMENT_XMLSERIAL(className, baseName) IMPLEMENT_SERIAL(className, baseName, 1)

//
// Example of serialization of CArray using derived CArrayXML template class that implements
// XML serialization
//
#include <afxtempl.h>

template<class TYPE, class ARG_TYPE = const TYPE&>
class CArrayXML : public CArray<TYPE, ARG_TYPE>
{
public:
	virtual void Serialize(CArchive& ar)
	{
		CXMLArchive& xmlArchive = static_cast<CXMLArchive&>(ar);
		CXMLArchiveNode* curNodePtr = xmlArchive.GetCurrentNode();

		if (xmlArchive.IsStoring())
		{
			// Storing
			for (int arrayIndex = 0; arrayIndex < GetSize(); arrayIndex++)
			{
				GetAt(arrayIndex)->Serialize(xmlArchive);
			}
		}
		else
		{
			// Loading
			int numberObjects = curNodePtr->GetNoChildren();

			for (int i = 0; i < numberObjects; i++, curNodePtr->GetNextChildIndex())
			{
				CString childNodeName = curNodePtr->GetChildName(i);

				CObject* newItemPtr = CXMLArchiveNode::CreateObject(childNodeName);

				if (newItemPtr == NULL)
				{
					continue;
				}

				newItemPtr->Serialize(xmlArchive);

				Add(static_cast<TYPE>(newItemPtr));
			}
		}
	}
};

// End XML Archive support
///////////////////////////////////////////////////////////////////////////////////////


